(* Calcul de l'hologramme d'un ou de plusieurs points, puis impression
   Gestion des points comme objets avec (re)dplacement, suppression ... *)
(* Procdure de calcul 'CalculerHologramme' entirement commente et procdure
   'CalculerHologrammeOptimise' optimise pour gain de temps de calcul de 1  5 x *)

(* Dvelopp par Cyril ROUSSILLON sous Borland Delphi,
   dans le cadre des Olympiades de Physique 2001,
   quipe sur l'holographie du Lyce Xavier Marmier  PONTARLIER *)
// Pour toute remarque, cyril@crtek.fr.st
//                      www.crteknologies.fr.st
// ou le site de notre professeur, http://perso.wanadoo.fr/jussiaux.software


unit Principal;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, ComCtrls, StdCtrls, Buttons, Printers, ShellAPI, Math;

type
  TF = class(TForm)
    Shape1: TShape; Shape2: TShape; Shape3: TShape; Shape4: TShape; Shape5: TShape;
    Shape6: TShape; Shape7: TShape; Shape8: TShape; Shape9: TShape; Shape10: TShape;
    ImageXY: TImage; ImageZY: TImage;
    lbEtiqX: TLabel; lbEtiqZ: TLabel; lbEtiqY1: TLabel; lbEtiqY2: TLabel;
    lbSelX: TLabel; lbSelY: TLabel; lbSelZ: TLabel; edSelX: TEdit;  edSelY: TEdit;  edSelZ: TEdit;

    MainMenu: TMainMenu;
    miFichier: TMenuItem; miOuvrir: TMenuItem; miEnregistrer: TMenuItem;
    miEnregistrerSous: TMenuItem; miN1: TMenuItem; miQuitter: TMenuItem;
    miActions: TMenuItem; miCalculer: TMenuItem; miImprimer: TMenuItem;
    miMontrer: TMenuItem; miAide: TMenuItem; miApropos: TMenuItem;
    miNouveau: TMenuItem; miRubrAide: TMenuItem; miN2: TMenuItem; miEnregHolo: TMenuItem;

    dlgOpen: TOpenDialog; dlgSave: TSaveDialog; dlgPrinterSetup: TPrinterSetupDialog;

    gbCouleur: TGroupBox; cbEpsilon: TCheckBox;
    gbEpsilon: TGroupBox; edEpsilon: TEdit; lbEpsilon: TLabel;
    rbVar: TRadioButton; rbPix: TRadioButton;

    edDecalX: TEdit;  edDecalY: TEdit; lbDecalX: TLabel; lbDecalY: TLabel;
    plSaisieHolo: TPanel; plReglages: TPanel; bvSupprimer: TBevel;
    gbDecalImpr: TGroupBox; gbSelection: TGroupBox;
    StatusBar: TStatusBar; ProgressBar: TProgressBar;
    lbSelZf: TLabel; edSelZf: TEdit;
    gbEchelleZ: TGroupBox; lbEchTZ: TLabel; lbEchPZ: TLabel; edEchTZ: TEdit; edEchPZ: TEdit;

    rbNoirBlanc: TRadioButton; rb256niv: TRadioButton;
    cbCouleur1: TComboBox; cbCouleur2: TComboBox;
    sbSupprimer: TSpeedButton; lbTaille: TLabel; edEchXY: TEdit;
    rbTminL: TRadioButton; edCoteHolo: TEdit; lbCoteHolo: TLabel;
    gbMateriel: TGroupBox; lbResImp: TLabel; edResImp: TEdit;
    edLambda: TEdit; lbLambda: TLabel;
    gbOptions: TGroupBox; cbPhiPi: TCheckBox; cbFondBl: TCheckBox;

    bvCalculer: TBevel; btnCalculer: TSpeedButton;
    bvMontrer : TBevel; btnMontrer : TSpeedButton;
    bvImprimer: TBevel; btnImprimer: TSpeedButton;

    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ImageXYMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ImageZYMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ImageXYMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ImageZYMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure edSelExit(Sender: TObject);
    procedure edIntExit(Sender: TObject);
    procedure sbSupprimerClick(Sender: TObject);
    procedure btnImprimerClick(Sender: TObject);
    procedure btnCalculerClick(Sender: TObject);
    procedure btnMontrerClick(Sender: TObject);
    procedure edXEnter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure miOuvrirClick(Sender: TObject);
    procedure miEnregistrerClick(Sender: TObject);
    procedure miEnregistrerSousClick(Sender: TObject);
    procedure miQuitterClick(Sender: TObject);
    procedure cbEpsilonClick(Sender: TObject);
    procedure rbEpsClick(Sender: TObject);
    procedure miAproposClick(Sender: TObject);
    procedure edEchZExit(Sender: TObject);
    procedure miNouveauClick(Sender: TObject);
    procedure rbCouleurClick(Sender: TObject);
    procedure edXKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure miRubrAideClick(Sender: TObject);
    procedure rbMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure edCoteHoloExit(Sender: TObject);
    procedure miEnregHoloClick(Sender: TObject);
    procedure edEpsilonExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  // Structure TPoint
  TPoint3D = Class
  Public
    X, Y, Z: SmallInt;
  End;

  // Structure THoloObj
  THoloObj = Class
  Public
    X, Y, Z: Byte;
    procedure DessinerSel;
    procedure Deplacer(XY: Boolean);
    procedure EffacerSel;
  End;

  // Structure THoloProp
  THoloProp = Class
  Public
    Xf, Yf: SmallInt;
    EtendEps: Integer;
    Coeff: Single;
  End;

  THoloProp2 = Class
  Public
    Xf, Yf: SmallInt;
    EtendEps: Integer;
    Zf: Single;
  End;

  // Structure TChgtCoul
  TChgtCoul = Class
  Public
    OO: Byte;      // Ordonne  l'origine
    CD: ShortInt;  // Coefficient directeur
  End;

Var
  F: TF;

implementation

uses Affichage, Apropos;
{$R *.DFM}

Type
  Efichier = class(Exception);

Var
  Deplacement: Boolean = False;
  Actualiser: Boolean = True;
  Decal, Curseur, Nouveau: TPoint3D;
  R, V, B: TChgtCoul;
  Objets: Array Of THoloObj;
  nbObjets: Integer = 0;        // Pour l'instant les 'objets' ne sont que des points et le resteront srement
  ObjActif: Integer = -1;
  nPixels: Integer;
  Enreg: Boolean = False;
  NoirBlanc: Boolean;

//----------------------------------------------------------------------------------------------
// Form1.Create
procedure TF.FormCreate(Sender: TObject);
begin
  ImageXY.Canvas; ImageZY.Canvas;
  Curseur := TPoint3D.Create;
  Decal := TPoint3D.Create;
  Nouveau := TPoint3D.Create;
  R := TChgtCoul.Create; V := TChgtCoul.Create; B := TChgtCoul.Create;
  Curseur.X := 100; Curseur.Z := 100;
  Nouveau.X := 100; Nouveau.Z := 100;
  cbCouleur1.ItemIndex := 0;
  cbCouleur2.ItemIndex := 1;
  edEchTZ.Text := FloatToStr(0.5);  // Pour qu'il n'y ait pas de pb de sparateur dcimal
  edLambda.Text := FloatToStr(632.8);
end;

////////////////////////////////////////////////////////////////////////////////////////////////
//**********************************************************************************************
//   CALCULS
//**********************************************************************************************
////////////////////////////////////////////////////////////////////////////////////////////////

Procedure TraduireCouleurs();
Begin
  If F.rbNoirBlanc.Checked Then NoirBlanc := True Else
  Begin
    NoirBlanc := False;
    Case F.cbCouleur1.ItemIndex Of
      0: Begin R.OO := 0  ; V.OO := 0  ; B.OO := 0   End;
      1: Begin R.OO := 255; V.OO := 255; B.OO := 255 End;
      2: Begin R.OO := 255; V.OO := 0  ; B.OO := 0   End;
      3: Begin R.OO := 0  ; V.OO := 255; B.OO := 0   End;
      4: Begin R.OO := 0  ; V.OO := 0  ; B.OO := 255 End;
      5: Begin R.OO := 255; V.OO := 255; B.OO := 0   End;
      6: Begin R.OO := 255; V.OO := 0  ; B.OO := 255 End;
      7: Begin R.OO := 0  ; V.OO := 255; B.OO := 255 End;
    End;
    Case F.cbCouleur2.ItemIndex Of
      0: Begin If R.OO = 0 Then R.CD := 0 Else R.CD := -1;
               If V.OO = 0 Then V.CD := 0 Else V.CD := -1;
               If B.OO = 0 Then B.CD := 0 Else B.CD := -1; End;
      1: Begin If R.OO = 0 Then R.CD := 1 Else R.CD := 0 ;
               If V.OO = 0 Then V.CD := 1 Else V.CD := 0 ;
               If B.OO = 0 Then B.CD := 1 Else B.CD := 0 ; End;
      2: Begin If R.OO = 0 Then R.CD := 1 Else R.CD := 0 ;
               If V.OO = 0 Then V.CD := 0 Else V.CD := -1;
               If B.OO = 0 Then B.CD := 0 Else B.CD := -1; End;
      3: Begin If R.OO = 0 Then R.CD := 0 Else R.CD := -1;
               If V.OO = 0 Then V.CD := 1 Else V.CD := 0 ;
               If B.OO = 0 Then B.CD := 0 Else B.CD := -1; End;
      4: Begin If R.OO = 0 Then R.CD := 0 Else R.CD := -1;
               If V.OO = 0 Then V.CD := 0 Else V.CD := -1;
               If B.OO = 0 Then B.CD := 1 Else B.CD := 0 ; End;
      5: Begin If R.OO = 0 Then R.CD := 1 Else R.CD := 0 ;
               If V.OO = 0 Then V.CD := 1 Else V.CD := 0 ;
               If B.OO = 0 Then B.CD := 0 Else B.CD := -1; End;
      6: Begin If R.OO = 0 Then R.CD := 1 Else R.CD := 0 ;
               If V.OO = 0 Then V.CD := 0 Else V.CD := -1;
               If B.OO = 0 Then B.CD := 1 Else B.CD := 0; End;
      7: Begin If R.OO = 0 Then R.CD := 0 Else R.CD := -1;
               If V.OO = 0 Then V.CD := 1 Else V.CD := 0;
               If B.OO = 0 Then B.CD := 1 Else B.CD := 0; End;
    End;
  End;
End;


//---------------------------------------------------------------------------------------------
// CalculerHologramme
Procedure CalculerHologramme;
Var
  Phi, eclairReel, EchTZ, EchPZ, p, Limite, lambda: Double;
  i, j, k, resImp, Marge: Integer;
  coeffTo255, coeffTo0, etendueEps, coeffAng, Max, PhiPi: Double;
  epsilon, epsVar, epsPix: Boolean;
  Chrono: Cardinal;
  ObjProp: Array Of THoloProp2;
begin
  //----- Rcuprer paramtres et initialisation
  With F Do
  Begin
    Chrono := GetTickCount();                         // on lance le chrono
    resImp := StrToInt(edResImp.Text);                // rsolution d'impression
    EchTZ := StrToFloat(edEchTZ.Text) / 200;          // taille du repre ZY
    EchPZ := StrToFloat(edEchPZ.Text);                // distance du dbut du repre ZY
    nPixels := StrToInt(edCoteHolo.Text);             // dimmension hologramme
    p := (0.0254 / resImp);                           // taille d'un pixel de l'hologramme
    Marge := Trunc((100 - StrToInt(edEchXY.Text)) / 200 * nPixels);  // marge hologramme
    lambda := StrToFloat(edLambda.Text) / 1000000000; // longueur d'onde laser

    etendueEps := StrToFloat(edEpsilon.Text);         // etendue de l'epsilon
    epsilon := cbEpsilon.Checked;                     // epsilon ?
    epsVar := rbVar.Checked;                          // epsilon variations ?
    epsPix := rbPix.Checked;                          // epsilon pixels ?
    If cbPhiPi.Checked Then PhiPi := Pi Else PhiPi := 0;  // inverser couleurs ?
    If cbFondBl.Checked Then Limite := 0 Else Limite := 0.0000001;  // Fond blanc ou noir ?

    StatusBar.Panels.Items[7].Text := 'Prparation';
    ProgressBar.Max := nPixels;
    // pour chacune des composantes (RVB) on fixe la quantit de dpart (0 ou 255) ...
    TraduireCouleurs(); // ... de fin (0 ou 255) et la pente (-1, 0 ou 1) -> voir au-dessus
  End;

  //----- Prparation donnes objets
  SetLength(ObjProp, nbObjets);     // on fixe la taille du tableau de proprits des points
  For k := 0 To nbObjets - 1 Do
  Begin
    ObjProp[k] := THoloProp2.Create;  // on cre l'lment
    ObjProp[k].Zf := Objets[k].Z * EchTZ + EchPZ; // on enregistre la cote en m du point

    // on traduit l'etendue de l'epsilon en un rayon en pixel si ncessaire
    If epsPix Then ObjProp[k].EtendEps := Trunc(etendueEps)
    // Solution de V(X^2 + Z^2) - Z = k.lambda
    Else If epsVar Then ObjProp[k].EtendEps := Trunc((Sqrt(Sqr(etendueEps - 0.25) * Sqr(lambda) + 2 * (etendueEps - 0.25) * lambda * ObjProp[k].Zf) / p))
    // Solution > 0 de V(X^2 + Z^2) + lambda = V((X + k)^2 + Z^2)
    Else ObjProp[k].EtendEps := Trunc(
      (IntPower(etendueEps * p, 3) - etendueEps * p * Sqr(lambda) -
       Sqrt(Sqr(lambda) * IntPower(etendueEps * p, 4) -
            2 * IntPower(lambda, 4) * Sqr(etendueEps * p) -
            4 * IntPower(lambda, 4) * Sqr(EchPZ) +
            4 * Sqr(etendueEps * p) * Sqr(lambda) * Sqr(ObjProp[k].Zf)
       )) / (2 * Sqr(lambda) - 2 * Sqr(etendueEps * p)) / p);

    // on passe du repre de conception  celui de l'hologramme (de 0  nPixels)
    ObjProp[k].Xf := Trunc(Objets[k].X * ((nPixels - 2 * Marge) / 200) + Marge);
    ObjProp[k].Yf := Trunc(Objets[k].Y * ((nPixels - 2 * Marge) / 200) + Marge);
  End;

  //----- Prparation normalisation pour contraste optimal
  If epsilon And (nbObjets > 1) And Not(NoirBlanc) Then
  Begin
    Max := 0;
    For j := 0 To nPixels - 1 Do      // boucle ordonnes
    Begin
      F.ProgressBar.StepIt();         // on ajuste la ProgressBar
      Application.ProcessMessages();  // on laisse windows traiter ses messages
      For i := 0 To nPixels - 1 Do    // boucle abscisses
      Begin
        coeffTo0 := 0;
        For k := 0 To nbObjets - 1 Do
        BEGIN   // On ajoute tous les coefficients angulaires pour le point
          coeffAng := 1 - (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j)) / Sqr(ObjProp[k].EtendEps);
          If coeffAng >= 0 Then coeffTo0 := coeffTo0 + coeffAng;
        END;    // si il est + grand que Max et bien c'est Max
        If coeffTo0 > Max Then Max := coeffTo0;
      End;
    End;
    coeffTo0 := Max;  // Ca y est on a notre Max qui sera notre coefficient  0
  End Else coeffTo0 := nbObjets;  // si pas eps ou 1 pt ou noir et blanc c'est le nb de pts
  coeffTo255 := 127.5 / coeffTo0; // coefficient  255

  //----- Fiche
  // On cache la fiche de l'hologramme car sinon windows se sent oblig de rafraichir ...
  // ... constamment l'affichage et il occupe le processeur inutilement
  FHolo.Hide;
  //----- Calcul
  F.StatusBar.Panels.Items[7].Text := 'Calcul';
  F.ProgressBar.Position := 0;      // on remet la ProgressBar  0
  coeffAng := 1;                    // si pas d'epsilon toujours 1 donc aucun effet
  For j := 0 To nPixels - 1 Do      // boucle des ordonnes
  Begin
    F.ProgressBar.StepIt();         // on ajuste la ProgressBar
    Application.ProcessMessages();  // on laisse windows traiter ses messages
    For i := 0 To nPixels - 1 Do    // boucle des abscisses
    Begin
      eclairReel := 0;              // initialise  0
      For k := 0 To nbObjets - 1 Do // boucle des objets
      BEGIN
        If epsilon Then             // si epsilon
        Begin                       // on calcule coefficien angulaire
          coeffAng := 1 - (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j)) / Sqr(ObjProp[k].EtendEps);
          If coeffAng < 0 Then coeffAng := 0; // et si en dehors etendue annule tout avec 0
        End;                        // calcul de la phase 'Phi' (2*Pi*d/lambda)
        Phi := 2 * Pi / lambda * (Sqrt(Sqr(p) * (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j)) + Sqr(ObjProp[k].Zf)) - ObjProp[k].Zf);
        eclairReel := eclairReel + coeffAng * Cos(Phi + PhiPi); // on ajoute la contribution du point
      END;

      // Affichage
      If NoirBlanc Then If eclairReel < Limite
           Then FHolo.Image1.Canvas.Pixels[i, j] := clBlack
           Else FHolo.Image1.Canvas.Pixels[i, j] := clWhite
      Else Begin
        eclairReel := (eclairReel + coeffTo0) * coeffTo255;  // normalisation
        FHolo.Image1.Canvas.Pixels[i, j] := RGB(Trunc(R.OO + R.CD * eclairReel),
                                                Trunc(V.OO + V.CD * eclairReel),
                                                Trunc(B.OO + B.CD * eclairReel));
      End
    End
  End;

  //----- Terminer
  SetLength(ObjProp, 0);             // on libre 'ObjProp'
  Chrono := GetTickCount() - Chrono; // on arrte le chrono et on affiche tout
  F.StatusBar.Panels.Items[7].Text := 'Termin (' + FormatFloat('#0.#', Chrono / 1000) + 's)';
  F.ProgressBar.Position := 0;       // on rinitialise la ProgressBar
  If (MessageBeep(MB_ICONASTERISK) = False) Then Beep;  // un petit signal sonore
  FHolo.Show;                        // on montre l'hologramme
End;



//---------------------------------------------------------------------------------------------
// CalculerHologrammeOptimise
Procedure CalculerHologrammeOptimise;
Var
  coeffTo255, coeffTo0, etendueEps, PhiPi, eclair, EchTZ, EchPZ, p, Limite, lambda: Double;
  i, j, k, resImp, Marge: Integer;
  epsilon, epsVar, epsPix: Boolean;
  Chrono: Cardinal;
  ObjProp: Array Of THoloProp;
begin
  //----- Rcuprer paramtres et initialisation
  With F Do
  Begin
    Chrono := GetTickCount();
    resImp := StrToInt(edResImp.Text);
    EchTZ := StrToFloat(edEchTZ.Text) / 200;
    EchPZ := StrToFloat(edEchPZ.Text);
    nPixels := StrToInt(edCoteHolo.Text);
    p := (0.0254 / resImp);
    Marge := Trunc((100 - StrToInt(edEchXY.Text)) / 200 * nPixels);
    lambda := StrToFloat(edLambda.Text) / 1000000000;

    etendueEps := StrToFloat(edEpsilon.Text);
    epsilon := cbEpsilon.Checked;
    epsVar := rbVar.Checked;
    epsPix := rbPix.Checked;
    If cbPhiPi.Checked Then PhiPi := Pi Else PhiPi := 0;
    If cbFondBl.Checked Then Limite := 0 Else Limite := 0.0000001;

    StatusBar.Panels.Items[7].Text := 'Prparation';
    ProgressBar.Max := nPixels;
    TraduireCouleurs();
  End;

  //----- Prparation donnes objets
  SetLength(ObjProp, nbObjets);
  For k := 0 To nbObjets - 1 Do
  Begin
    ObjProp[k] := THoloProp.Create;
    coeffTo0 := Objets[k].Z * EchTZ + EchPZ;
    eclair := etendueEps * p;

    If epsPix Then ObjProp[k].EtendEps := Sqr(Trunc(etendueEps))
    Else If epsVar Then ObjProp[k].EtendEps := Trunc(Sqr((Sqrt(Sqr(etendueEps - 0.25) * Sqr(lambda) + 2 * (etendueEps - 0.25) * lambda * coeffTo0) / p)))
    Else ObjProp[k].EtendEps := Sqr(Trunc((IntPower(eclair, 3) - eclair * Sqr(lambda) -
       Sqrt(Sqr(lambda) * IntPower(eclair, 4) - 2 * IntPower(lambda, 4) * Sqr(eclair)
       - 4 * IntPower(lambda, 4) * Sqr(EchPZ) + 4 * Sqr(eclair) * Sqr(lambda) * Sqr(coeffTo0)))
       / (2 * Sqr(lambda) - 2 * Sqr(eclair)) / p));

    ObjProp[k].Coeff := Sqr(p) * Pi / (lambda * coeffTo0);
    ObjProp[k].Xf := Trunc(Objets[k].X * ((nPixels - 2 * Marge) / 200) + Marge);
    ObjProp[k].Yf := Trunc(Objets[k].Y * ((nPixels - 2 * Marge) / 200) + Marge);
  End;

  //----- Prparation normalisation pour contraste optimal
  If epsilon And (nbObjets > 1) And Not(NoirBlanc) Then
  Begin
    coeffTo255 := 0;
    For j := 0 To nPixels - 1 Do
    BEGIN
      F.ProgressBar.StepIt();
      Application.ProcessMessages();
      For i := 0 To nPixels - 1 Do
      Begin
        coeffTo0 := 0;
        For k := 0 To nbObjets - 1 Do
          If (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j)) < ObjProp[k].EtendEps Then
            coeffTo0 := coeffTo0 + 1 - (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j)) / ObjProp[k].EtendEps;
        If coeffTo0 > coeffTo255 Then coeffTo255 := coeffTo0;
      End;
    END;
    coeffTo0 := coeffTo255;
  End Else coeffTo0 := nbObjets;
  coeffTo255 := 127.5 / coeffTo0;

  FHolo.Hide;
  //----- Calcul
  F.StatusBar.Panels.Items[7].Text := 'Calcul';
  F.ProgressBar.Position := 0;
  For j := 0 To nPixels - 1 Do
  Begin
    F.ProgressBar.StepIt();
    Application.ProcessMessages();
    For i := 0 To nPixels - 1 Do
    BEGIN
      eclair := 0;
      For k := 0 To nbObjets - 1 Do
      Begin
        Marge := (Sqr(ObjProp[k].Xf - i) + Sqr(ObjProp[k].Yf - j));
        If Epsilon Then If Marge < ObjProp[k].EtendEps
          Then eclair := eclair + (1 - Marge / ObjProp[k].EtendEps) * Cos(ObjProp[k].Coeff * Marge + PhiPi)
          Else Else eclair := eclair + Cos(ObjProp[k].Coeff * Marge + PhiPi);
      End;

      // Affichage
      If NoirBlanc Then If eclair < Limite
           Then FHolo.Image1.Canvas.Pixels[i, j] := clBlack
           Else FHolo.Image1.Canvas.Pixels[i, j] := clWhite
      Else Begin
        eclair := (eclair + coeffTo0) * coeffTo255;
        FHolo.Image1.Canvas.Pixels[i, j] := RGB(Trunc(R.OO + R.CD * eclair),
                                                Trunc(V.OO + V.CD * eclair),
                                                Trunc(B.OO + B.CD * eclair));
      End
    END
  End;

  //----- Terminer
  SetLength(ObjProp, 0);
  Chrono := GetTickCount() - Chrono;
  F.StatusBar.Panels.Items[7].Text := 'Termin (' + FormatFloat('#0.#', Chrono / 1000) + 's)';
  F.ProgressBar.Position := 0;
  MessageBeep(MB_ICONASTERISK);
  FHolo.Show;
End;


//---------------------------------------------------------------------------------------------
// btnCalculer.Clic
procedure TF.btnCalculerClick(Sender: TObject);
begin
  ActiveControl := Nil;
  If ActiveControl <> Nil Then Exit;
  Try
    plReglages.Enabled := False;
		edCoteHoloExit(Sender);
    CalculerHologrammeOptimise;
    F.btnMontrer.Enabled := True;
    F.miMontrer.Enabled := True;
    F.miEnregHolo.Enabled := True;
  Finally plReglages.Enabled := True End;
end;


//---------------------------------------------------------------------------------------------
// btnImprimer.Clic
Procedure TF.btnImprimerClick(Sender: TObject);
Var
  i, j: Integer;
  decalImpX, decalImpY: Integer;
Begin
  ActiveControl := nil;
  If ActiveControl <> nil Then Exit;
  If dlgPrinterSetup.Execute Then
  Begin
		edCoteHoloExit(Sender);
    DecalImpX := StrToInt(edDecalX.Text);
    DecalImpY := StrToInt(edDecalY.Text);
    If Not(NoirBlanc) Then Begin rbNoirBlanc.Checked := True; CalculerHologrammeOptimise End;
    Printer.BeginDoc;
    For i := 0 To nPixels - 1 Do For j := 0 To nPixels - 1 Do
      Printer.Canvas.Pixels[i + decalImpX, j + DecalImpY] := FHolo.Image1.Canvas.Pixels[i, j];
    Printer.EndDoc;
  End;
End;


////////////////////////////////////////////////////////////////////////////////////////////////
//**********************************************************************************************
// GESTION SAISIE
//**********************************************************************************************
////////////////////////////////////////////////////////////////////////////////////////////////


//**********************************************************************************************
// Routines diverses
//**********************************************************************************************

//----------------------------------------------------------------------------------------------
// DessinerSel
Procedure THoloObj.DessinerSel();
Var
  i, j: Integer;
Begin
  For i := -4 To 4 Do For j := -4 To 4 Do
    If (Sqrt(i * i + j * j) < 5) Then
    Begin
      If F.ImageXY.Canvas.Pixels[X + i, Y + j] = clWhite
        Then F.ImageXY.Canvas.Pixels[X + i, Y + j] := clYellow;
      If F.ImageZY.Canvas.Pixels[Z + i, Y + j] = clWhite
        Then F.ImageZY.Canvas.Pixels[Z + i, Y + j] := clYellow;
    End;
End;

//----------------------------------------------------------------------------------------------
// EffacerSel
Procedure THoloObj.EffacerSel();
Var
  i, j: Integer;
Begin
  For i := -4 To 4 Do For j := -4 To 4 Do
    If (Sqrt(i * i + j * j) < 5) Then
    Begin
      If F.ImageXY.Canvas.Pixels[X + i, Y + j] = clYellow
        Then F.ImageXY.Canvas.Pixels[X + i, Y + j] := clWhite;
      If F.ImageZY.Canvas.Pixels[Z + i, Y + j] = clYellow
        Then F.ImageZY.Canvas.Pixels[Z + i, Y + j] := clWhite;
    End;
End;

//----------------------------------------------------------------------------------------------
// AutrePtXY
Function AutrePtXY(): Boolean;
Var
  i: Integer;
Begin
  Result := True;
  For i := 0 To nbObjets - 1 Do
    If ((i <> ObjActif) And (Objets[i].X = Objets[ObjActif].X)
      And (Objets[i].Y = Objets[ObjActif].Y)) Then Result := False;
End;

//----------------------------------------------------------------------------------------------
// AutrePtZY
Function AutrePtZY(): Boolean;
Var
  i: Integer;
Begin
  Result := True;
  For i := 0 To nbObjets - 1 Do
    If ((i <> ObjActif) And (Objets[i].Z = Objets[ObjActif].Z)
      And (Objets[i].Y = Objets[ObjActif].Y)) Then Result := False;
End;


//----------------------------------------------------------------------------------------------
// DeplacerPt
Procedure THoloObj.Deplacer(XY: Boolean);
Var
  X2, Y2: SmallInt;
Begin
  EffacerSel;
  If AutrePtXY Then  F.ImageXY.Canvas.Pixels[X, Y] := clWhite;
  If AutrePtZY Then  F.ImageZY.Canvas.Pixels[Z, Y] := clWhite;
  If XY Then X2 := Curseur.X - Decal.X Else X2 := Curseur.Z - Decal.Z;
  Y2 := Curseur.Y - Decal.Y;

  If X2 > 200 Then X2 := 200 Else If X2 < 0 Then X2 := 0;
  If XY Then X := Byte(X2) Else Z := Byte(X2);
  If XY Then Nouveau.X := X Else Nouveau.Z := Z;

  If Y2 > 200 Then Y := 200 Else If Y2 < 0 Then Y := 0 Else Y := Y2;
  F.ImageXY.Canvas.Pixels[X, Y] := clBlack;
  F.ImageZY.Canvas.Pixels[Z, Y] := clBlack;
  F.edSelX.Text := IntToStr(X - 100);
  F.edSelY.Text := IntToStr(Y - 100);
  F.edSelZ.Text := IntToStr(Z - 100);
  F.edSelZf.Text := FormatFloat('##0.###', Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
  DessinerSel;
End;

//----------------------------------------------------------------------------------------------
// ActiverPt
Procedure ActiverPt(X, Y: Integer; XY: Boolean);
Var
  i: Integer;
Const
  Marge: Integer = 3;
Begin
  If ObjActif <> -1 Then Objets[ObjActif].EffacerSel;
  ObjActif := -1;
  If XY Then For i := 0 To nbObjets - 1 Do
  Begin
    If ((Objets[i].X >= X - Marge) And (Objets[i].X <= X + Marge)) And
       ((Objets[i].Y >= Y - Marge) And (Objets[i].Y <= Y + Marge)) Then ObjActif := i;
  End Else For i := 0 To nbObjets - 1 Do
    If ((Objets[i].Z >= X - Marge) And (Objets[i].Z <= X + Marge)) And
       ((Objets[i].Y >= Y - Marge) And (Objets[i].Y <= Y + Marge)) Then ObjActif := i;
  If ObjActif <> -1 Then
  Begin
    F.gbSelection.Enabled := True;
    Objets[ObjActif].DessinerSel;
    Deplacement := True;
    Decal.X := Curseur.X - Objets[ObjActif].X;
    Decal.Y := Curseur.Y - Objets[ObjActif].Y;
    Decal.Z := Curseur.Z - Objets[ObjActif].Z;
    F.edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
    F.edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
    F.edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
    F.edSelZf.Text := FormatFloat('0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
    F.sbSupprimer.Enabled := True;
    Nouveau.X := Curseur.X; Nouveau.Z := Curseur.Z;
  End Else
  Begin
    F.gbSelection.Enabled := False;
    F.sbSupprimer.Enabled := False;
    F.edSelX.Text := ''; F.edSelY.Text := ''; F.edSelZ.Text := ''; F.edSelZf.Text := '';
  End;
End;

//----------------------------------------------------------------------------------------------
// AjouterPt
Procedure AjouterPt(Point: TPoint3D; XY: Boolean);
Begin
  If ObjActif <> -1 Then Objets[ObjActif].EffacerSel
  Else Begin
    F.gbSelection.Enabled := True;
    F.sbSupprimer.Enabled := True;
    F.btnCalculer.Enabled := True;
    F.miCalculer.Enabled := True;
    F.btnImprimer.Enabled := True;
    F.miImprimer.Enabled := True;
    F.miEnregistrerSous.Enabled := True;
    F.miEnregistrer.Enabled := True;
  End;
  Inc(nbObjets);
  ObjActif := nbObjets - 1;
  SetLength(Objets, nbObjets);
  Objets[ObjActif] := THoloObj.Create;
  If XY Then Begin Objets[ObjActif].X := Curseur.X; Objets[ObjActif].Z := Nouveau.Z End
        Else Begin Objets[ObjActif].Z := Curseur.Z; Objets[ObjActif].X := Nouveau.X End;
  Objets[ObjActif].Y := Curseur.Y;
  Objets[ObjActif].DessinerSel;
  Nouveau.X := Objets[ObjActif].X; Nouveau.Z := Objets[ObjActif].Z;
  F.ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
  F.ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack;
  F.edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
  F.edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
  F.edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
  F.edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
  F.sbSupprimer.Caption := '   Supprimer (' + IntToStr(nbObjets) + ' pts)';
End;

//**********************************************************************************************
// Evnements
//**********************************************************************************************

//----------------------------------------------------------------------------------------------
// Form.Activate
procedure TF.FormActivate(Sender: TObject);
begin
  ActiveControl := nil;
end;

//----------------------------------------------------------------------------------------------
// ImageXY.MouseMove
procedure TF.ImageXYMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar.Panels.Items[1].Text := IntToStr(X - 100);
  StatusBar.Panels.Items[3].Text := IntToStr(Y - 100);
  Curseur.X := X;
  Curseur.Y := Y;
  If Deplacement Then Objets[ObjActif].Deplacer(True);
end;

//----------------------------------------------------------------------------------------------
// ImageZY.MouseMove
procedure TF.ImageZYMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  StatusBar.Panels.Items[5].Text := IntToStr(X - 100);
  StatusBar.Panels.Items[3].Text := IntToStr(Y - 100);
  Curseur.Z := X;
  Curseur.Y := Y;
  If Deplacement Then Objets[ObjActif].Deplacer(False);
end;

//----------------------------------------------------------------------------------------------
// ImageXY.MouseDown
procedure TF.ImageXYMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ActiveControl := nil;
  If ActiveControl <> nil Then Exit;
  If Button = mbRight Then
  Begin
    AjouterPt(Curseur, True);
    Deplacement := True;
    Decal.X := 0; Decal.Y := 0; Decal.Z := 0;
  End Else
  If ObjActif = -1 Then ActiverPt(Curseur.X, Curseur.Y, True)
  Else If ImageXY.Canvas.Pixels[Curseur.X, Curseur.Y] = clYellow Then
    Begin
      Deplacement := True;
      Decal.X := Curseur.X - Objets[ObjActif].X;
      Decal.Y := Curseur.Y - Objets[ObjActif].Y;
      Decal.Z := Curseur.Z - Objets[ObjActif].Z;
    End Else ActiverPt(Curseur.X, Curseur.Y, True);
end;

//----------------------------------------------------------------------------------------------
// ImageZY.MouseDown
procedure TF.ImageZYMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ActiveControl := nil;
  If ActiveControl <> nil Then Exit;
  If Button = mbRight Then
  Begin
    AjouterPt(Curseur, False);
    Deplacement := True;
    Decal.X := 0; Decal.Y := 0; Decal.Z := 0;
  End Else
  If ObjActif = -1 Then ActiverPt(Curseur.Z, Curseur.Y, False)
  Else If ImageZY.Canvas.Pixels[Curseur.Z, Curseur.Y] = clYellow Then
    Begin
      Deplacement := True;
      Decal.X := Curseur.X - Objets[ObjActif].X;
      Decal.Y := Curseur.Y - Objets[ObjActif].Y;
      Decal.Z := Curseur.Z - Objets[ObjActif].Z;
    End Else ActiverPt(Curseur.Z, Curseur.Y, False);
end;

//----------------------------------------------------------------------------------------------
// Image.MouseUp
procedure TF.ImageMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If Deplacement Then Deplacement := False;
end;

//----------------------------------------------------------------------------------------------
// Form.KeyDown
procedure TF.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  If Key = VK_ESCAPE Then ActiverPt(-1, -1, True) Else
  If ((Key = VK_ADD) Or (Key = VK_SUBTRACT)) And (nbObjets <> 0) Then
  Begin
    If ObjActif <> -1 Then Objets[ObjActif].EffacerSel;
    If Key = VK_ADD Then
    Begin
      If ObjActif < (nbObjets - 1) Then Inc(ObjActif) Else ObjActif := 0;
    End Else
    If Key = VK_SUBTRACT Then
    Begin
      If ObjActif > 0 Then Dec(ObjActif) Else ObjActif := nbObjets - 1;
    End;
    Objets[ObjActif].DessinerSel;
    edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
    edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
    edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
    F.edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
    Nouveau.X := Objets[ObjActif].X; Nouveau.Z := Objets[ObjActif].Z;
    gbSelection.Enabled := True; sbSupprimer.Enabled := True;
  End Else
  If Key = VK_DELETE Then If nbObjets > 0 Then sbSupprimerClick(Sender) Else Else
  If ObjActif <> -1 Then
  Begin
    Objets[ObjActif].EffacerSel;
    Case Key Of
    VK_LEFT: Begin
      If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].X <= 0 Then Objets[ObjActif].X := 0 Else Dec(Objets[ObjActif].X);
      edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
      ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
      Nouveau.X := Objets[ObjActif].X; End;
    VK_RIGHT: Begin
      If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].X >= 200 Then Objets[ObjActif].X := 200 Else Inc(Objets[ObjActif].X);
      edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
      ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
      Nouveau.X := Objets[ObjActif].X; End;
    VK_UP: Begin
      If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
      If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].Y <= 0 Then Objets[ObjActif].Y := 0 Else Dec(Objets[ObjActif].Y);
      edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
      ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
      ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack; End;
    VK_DOWN: Begin
      If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
      If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].Y >= 200 Then Objets[ObjActif].Y := 200 Else Inc(Objets[ObjActif].Y);
      edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
      ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
      ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack; End;
    VK_PRIOR: Begin
      If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].Z >= 200 Then Objets[ObjActif].Z := 200 Else Inc(Objets[ObjActif].Z);
      edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
      ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack;
      edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
      Nouveau.Z := Objets[ObjActif].Z; End;
    VK_NEXT: Begin
      If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
      If Objets[ObjActif].Z <= 0 Then Objets[ObjActif].Z := 0 Else Dec(Objets[ObjActif].Z);
      edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
      ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack;
      edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
      Nouveau.Z := Objets[ObjActif].Z; End;
    End;
    Objets[ObjActif].DessinerSel;
  End;
end;

//---------------------------------------------------------------------------------------------
// edSel.Exit
procedure TF.edSelExit(Sender: TObject);
Var
  edSel: TEdit;
begin
  edSel := Sender As TEdit;
  If gbSelection.Enabled = False Then Exit;
	Try StrToInt(edSel.Text)
  Except On E: EConvertError Do Begin Actualiser := False; ActiveControl := (Sender As TWinControl); Raise End End;
  If ObjActif = -1 Then Exit;
  Objets[ObjActif].EffacerSel;
  Try
   If (StrToInt(edSel.Text) > 100) Then edSel.Text := IntToStr(100) Else
   If (StrToInt(edSel.Text) < -100) Then edSel.Text := IntToStr(-100);
  Except End;
  If Sender = edSelX Then
  Begin
    If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
    Objets[ObjActif].X := StrToInt(edSelX.Text) + 100;
    ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
    Nouveau.X := Objets[ObjActif].X;
  End Else
  If Sender = edSelZ Then
  Begin
    If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
    Objets[ObjActif].Z := StrToInt(edSelZ.Text) + 100;
    ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack;
    F.edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text));
    Nouveau.Z := Objets[ObjActif].Z;
  End Else
  Begin
    If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
    If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
    Objets[ObjActif].Y := StrToInt(edSelY.Text) + 100;
    ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clBlack;
    ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clBlack;
  End;
  Objets[ObjActif].DessinerSel;
end;

//---------------------------------------------------------------------------------------------
// edX.KeyDown
procedure TF.edXKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  If Key = VK_ESCAPE Then
  Begin
    (Sender As TEdit).Text := (Sender As TEdit).Hint;
    (Sender As TEdit).SelectAll
  End Else If Key = VK_RETURN Then
  Begin
    (Sender As TEdit).Hint := (Sender As TEdit).Text;
    ActiveControl := nil;
  End
end;

//---------------------------------------------------------------------------------------------
// edInt.Exit
procedure TF.edIntExit(Sender: TObject);
begin
  Try If Sender = edLambda Then StrToFloat(edLambda.Text) Else StrToInt((Sender As TEdit).Text);
  Except On EConvertError Do Begin Actualiser := False; ActiveControl := (Sender As TWinControl); Raise End End;
end;

//---------------------------------------------------------------------------------------------
// edEchZ.Exit
procedure TF.edEchZExit(Sender: TObject);
begin
  Try
    If ObjActif <> -1
      Then F.edSelZf.Text := FormatFloat('##0.###', Objets[ObjActif].Z * StrToFloat(F.edEchTZ.Text) / 200 + StrToFloat(F.edEchPZ.Text))
      Else Begin StrToFloat(F.edEchTZ.Text); StrToFloat(F.edEchPZ.Text) End;
  Except On EConvertError Do Begin Actualiser := False; ActiveControl := (Sender As TWinControl); Raise End End;
end;

//---------------------------------------------------------------------------------------------
// edCoteHolo.Exit
procedure TF.edCoteHoloExit(Sender: TObject);
begin
  Try nPixels := StrToInt(edCoteHolo.Text)
  Except On E: EConvertError Do Begin Actualiser := False; ActiveControl := edCoteHolo; Raise End End;
  { Quand on modifie le canevas d'une image, on fixe sa taille dfinitivement.
    Pour pouvoir calculer un hologramme plus grand on doit donc dtruire l'image
    et la reconstruire avec une nouvelle taille.
    Si l'hologramme est trop grand et provoque une exception de manque de ressources
    on en informe l'utilisateur et on l'oblige  changer de valeur. }
  If nPixels <> FHolo.ClientWidth Then
  With FHolo Do
  Begin
		F.btnMontrer.Enabled := False;
	  Image1.Free;
	  Image1 := TImage.Create(FHolo);
    Image1.Parent := FHolo;
	  ClientWidth := nPixels;
	  ClientHeight := nPixels;
    Image1.Width := nPixels;
    Image1.Height := nPixels;
    Try Image1.Canvas.Pixels[0, 0] := clWhite
    Except On EOutOfResources Do Begin Actualiser := False; F.ActiveControl := edCoteHolo; Raise End End;
	  If Left < 0 Then Left := 10;
	  If Top < 0 Then Top := 10;
    Image1.OnClick := Image1Click;
    Image1.OnMouseDown := Image1MouseDown;
    Image1.OnMouseMove := Image1MouseMove;
    Image1.OnMouseUp := Image1MouseUp;
  End;
end;

//---------------------------------------------------------------------------------------------
// sbSupprimer.Clic
procedure TF.sbSupprimerClick(Sender: TObject);
Var
  i: Integer;
begin
  Objets[ObjActif].EffacerSel();
  If AutrePtXY Then ImageXY.Canvas.Pixels[Objets[ObjActif].X, Objets[ObjActif].Y] := clWhite;
  If AutrePtZY Then ImageZY.Canvas.Pixels[Objets[ObjActif].Z, Objets[ObjActif].Y] := clWhite;
  For i := ObjActif To nbObjets - 2 Do
  Begin
    Objets[i].X := Objets[i + 1].X;
    Objets[i].Y := Objets[i + 1].Y;
    Objets[i].Z := Objets[i + 1].Z;
  End;
  Dec(nbObjets); Dec(ObjActif);
  SetLength(Objets, nbObjets);
  If ObjActif < 0 Then If nbObjets <> 0 Then ObjActif := 0 Else ObjActif := -1;
  If nbObjets <> 0 Then
  Begin
    Objets[ObjActif].DessinerSel;
    edSelX.Text := IntToStr(Objets[ObjActif].X - 100);
    edSelY.Text := IntToStr(Objets[ObjActif].Y - 100);
    edSelZ.Text := IntToStr(Objets[ObjActif].Z - 100);
  End Else
  Begin
    sbSupprimer.Enabled := False;
    gbSelection.Enabled := False;
    edSelX.Text := ''; edSelY.Text := ''; edSelZ.Text := ''; edSelZf.Text := '';
    btnCalculer.Enabled := False;
    miCalculer.Enabled := False;
    btnImprimer.Enabled := False;
    miImprimer.Enabled := False;
    miEnregistrerSous.Enabled := False;
    miEnregistrer.Enabled := False;
  End;
  ActiveControl := nil;
  sbSupprimer.Caption := '   Supprimer (' + IntToStr(nbObjets) + ' pts)';
end;

//---------------------------------------------------------------------------------------------
// cbEpsilon.Clic
procedure TF.cbEpsilonClick(Sender: TObject);
begin
  If cbEpsilon.Checked Then gbEpsilon.Enabled := True Else gbEpsilon.Enabled := False;
  If Not(rb256niv.Checked) And cbEpsilon.Checked Then cbFondBl.Enabled := True Else cbFondBl.Enabled := False;
  ActiveControl := nil;
end;

//---------------------------------------------------------------------------------------------
// rbCouleur.Clic
procedure TF.rbCouleurClick(Sender: TObject);
begin
  If rb256niv.Checked
    Then Begin cbCouleur1.Enabled := True ; cbCouleur2.Enabled := True  End
    Else Begin cbCouleur1.Enabled := False; cbCouleur2.Enabled := False End;
  If Not(rb256niv.Checked) And cbEpsilon.Checked Then cbFondBl.Enabled := True Else cbFondBl.Enabled := False;
  ActiveControl := nil;
end;

//---------------------------------------------------------------------------------------------
// rbAuto.Clic
procedure TF.rbEpsClick(Sender: TObject);
begin
  If rbVar.Checked And (rbVar.Hint <> 'C') Then
  Begin
    If rbPix.Hint = 'C' Then rbPix.Hint := edEpsilon.Text Else
    If rbTminL.Hint = 'C' Then rbTminL.Hint := edEpsilon.Text;
    edEpsilon.Text := rbVar.Hint;
    rbVar.Hint := 'C';
    edEpsilon.Hint := edEpsilon.Text;
  End Else
  If rbPix.Checked And (rbPix.Hint <> 'C') Then
  Begin
    If rbVar.Hint = 'C' Then rbVar.Hint := edEpsilon.Text Else
    If rbTminL.Hint = 'C' Then rbTminL.Hint := edEpsilon.Text;
    edEpsilon.Text := rbPix.Hint;
    rbPix.Hint := 'C';
    edEpsilon.Hint := edEpsilon.Text;
  End Else If rbTminL.Hint <> 'C' Then
  Begin
    If rbVar.Hint = 'C' Then rbVar.Hint := edEpsilon.Text Else
    If rbPix.Hint = 'C' Then rbPix.Hint := edEpsilon.Text;
    edEpsilon.Text := rbTminL.Hint;
    rbTminL.Hint := 'C';
    edEpsilon.Hint := edEpsilon.Text;
  End;
  ActiveControl := nil;
end;

//---------------------------------------------------------------------------------------------
// btnMontrer.Clic
procedure TF.btnMontrerClick(Sender: TObject);
begin
  ActiveControl := Nil;
  If (ActiveControl = Nil) And btnMontrer.Enabled Then FHolo.Visible := Not(FHolo.Visible);
end;

//---------------------------------------------------------------------------------------------
// edSelX.Enter
procedure TF.edXEnter(Sender: TObject);
begin
	If Actualiser Then
	  If Sender Is TEdit Then (Sender As TEdit).Hint := (Sender As TEdit).Text
  Else Else Actualiser := True;
end;

//---------------------------------------------------------------------------------------------
// edEpsilon.Exit
procedure TF.edEpsilonExit(Sender: TObject);
begin
  Try
    If rbPix.Checked Then StrToInt(edEpsilon.Text) Else StrToFloat(edEpsilon.Text);
  Except On EConvertError Do Begin Actualiser := False; ActiveControl := edEpsilon; Raise End End;
end;

//---------------------------------------------------------------------------------------------
// Form.Destroy
procedure TF.FormDestroy(Sender: TObject);
begin
  SetLength(Objets, 0);
end;

//---------------------------------------------------------------------------------------------
// rb.MouseUp
procedure TF.rbMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ActiveControl := nil;
end;

//**********************************************************************************************
// Gestion fichiers
//**********************************************************************************************

//---------------------------------------------------------------------------------------------
// Sauver
Procedure Sauver(NomFichier: String; Nouveau: Boolean);
Var
  Buffer: Array[0..6] Of Byte;
  HandleFichier, i: Integer;
  X: Byte;
  Y: Word;
Begin
  If Nouveau Then HandleFichier := FileCreate(NomFichier)
    Else HandleFichier := FileOpen(NomFichier, fmOpenWrite);
  Try
    FileSeek(HandleFichier, 0, 0);
    // octets d'identification
    Buffer[0] := Byte('H');
    Buffer[1] := Byte('1');
    // octet options
    X := 0;
    If F.cbFondBl.Checked Then X := X + 32;
    If F.cbPhiPi.Checked Then X := X + 16;
    If F.cbEpsilon.Checked Then X := X + 8;
    If F.rbPix.Checked Then X := X + 4;
    If F.rbVar.Checked Then X := X + 2;
    If F.rbTminL.Checked Then X := X + 1;
    Buffer[2] := X;
    // taille holo
    Y := StrToInt(F.edCoteHolo.Text);
    Buffer[3] := Y mod 256; Buffer[4] := Y div 256;
    // echelle XY
    Y := StrToInt(F.edEchXY.Text);
    Buffer[5] := Y mod 256; Buffer[6] := Y div 256;
    FileWrite(HandleFichier, Buffer, 7);
    // EchPZ
    X := Length(F.edEchPZ.Text);
    Buffer[0] := X;
    FileWrite(HandleFichier, Buffer, 1);
    For i := 0 To X - 1 Do
    Begin
      Buffer[i] := Byte(F.edEchPZ.Text[i + 1]);
      Case Buffer[i] Of 48..57: Else Buffer[i] := Byte('.') End;
    End;
    FileWrite(HandleFichier, Buffer, X);
    // EchTZ
    X := Length(F.edEchTZ.Text);
    Buffer[0] := X;
    FileWrite(HandleFichier, Buffer, 1);
    For i := 0 To X - 1 Do
    Begin
      Buffer[i] := Byte(F.edEchTZ.Text[i + 1]);
      Case Buffer[i] Of 48..57: Else Buffer[i] := Byte('.') End;
    End;
    FileWrite(HandleFichier, Buffer, X);
    // Epsilon
    X := Length(F.edEpsilon.Text);
    Buffer[0] := X;
    FileWrite(HandleFichier, Buffer, 1);
    For i := 0 To X - 1 Do
    Begin
      Buffer[i] := Byte(F.edEpsilon.Text[i + 1]);
      Case Buffer[i] Of 48..57: Else Buffer[i] := Byte('.') End;
    End;
    FileWrite(HandleFichier, Buffer, X);
    // nb de points
    Buffer[0] := nbObjets mod 256; Buffer[1] := nbObjets div 256;
    FileWrite(HandleFichier, Buffer, 2);
    // donnes
    For i := 0 To nbObjets - 1 Do
    Begin
      Buffer[0] := Objets[i].X;
      Buffer[1] := Objets[i].Y;
      Buffer[2] := Objets[i].Z;
      FileWrite(HandleFichier, Buffer, 3);
    End;
  Finally FileClose(HandleFichier) End;
  F.ActiveControl := nil;
End;

//---------------------------------------------------------------------------------------------
// miEnregistrerSous.Clic
procedure TF.miEnregistrerSousClick(Sender: TObject);
begin
  ActiveControl := nil;
  If ActiveControl <> nil Then Exit;
  dlgSave.DefaultExt := 'hol';
  dlgSave.Filter := 'Fichiers hologrammes (*.hol)|*.hol';
  If dlgSave.Execute Then
  Begin
    Sauver(dlgSave.FileName, True);
    dlgOpen.FileName := dlgSave.FileName;
    Enreg := True;
    miEnregistrer.Enabled := True;
  End;
end;

//---------------------------------------------------------------------------------------------
// miEnregistrer.Clic
procedure TF.miEnregistrerClick(Sender: TObject);
begin
  ActiveControl := nil;
  If ActiveControl <> nil Then Exit;
  If Enreg Then Sauver(dlgOpen.FileName, False) Else miEnregistrersousClick(Sender);
end;

//---------------------------------------------------------------------------------------------
// miOuvrir.Clic
procedure TF.miOuvrirClick(Sender: TObject);
Var
  Buffer: Array[0..8] Of Byte;
  HandleFichier, i: Integer;
  X: Byte;
  Y: Word;
begin
  If dlgOpen.Execute Then
  Begin
    HandleFichier := FileOpen(dlgOpen.FileName, fmOpenRead);
    Try
      If (HandleFichier = -1) Then Raise Efichier.Create('Il s''est produit une erreur fichier');
      FileSeek(HandleFichier, 0, 0);
      ImageXY.Canvas.FillRect(Rect(0, 0, 201, 201));
      ImageZY.Canvas.FillRect(Rect(0, 0, 201, 201));
      If ExtractFileExt(dlgOpen.FileName) = '.loh' Then
      Begin
        nbObjets :=  Trunc(FileSeek(HandleFichier, 0, 2) / 3);
        FileSeek(HandleFichier, 0, 0);
        SetLength(Objets, nbObjets);
        For i := 0 To nbObjets - 1 Do
        Begin
          If FileRead(HandleFichier, Buffer, 3) = 0 Then Raise Efichier.Create('Il s''est produit une erreur fichier');
          Objets[i] := THoloObj.Create();
          Objets[i].X := Byte(Buffer[0]);
          Objets[i].Y := Byte(Buffer[1]);
          Objets[i].Z := Byte(Buffer[2]);
          ImageXY.Canvas.Pixels[Objets[i].X, Objets[i].Y] := clBlack;
          ImageZY.Canvas.Pixels[Objets[i].Z, Objets[i].Y] := clBlack;
        End;
        Exit;
      End;
      FileRead(HandleFichier, Buffer, 7);
      // octets d'identification
      If (Buffer[0] <> Byte('H')) Or (Buffer[1] <> Byte('1')) Then Raise Efichier.Create('Il s''est produit une erreur fichier');
      // octet options
      X := Buffer[2];
      If (X And 32) <> 0 Then F.cbFondBl.Checked := True Else F.cbFondBl.Checked := False;
      If (X And 16) <> 0 Then F.cbPhiPi.Checked := True Else F.cbPhiPi.Checked := False;
      If (X And 8) <> 0 Then F.cbEpsilon.Checked := True Else F.cbEpsilon.Checked := False;
      If (X And 4) <> 0 Then F.rbPix.Checked := True Else F.rbPix.Checked := False;
      If (X And 2) <> 0 Then F.rbVar.Checked := True Else F.rbVar.Checked := False;
      If (X And 1) <> 0 Then F.rbTminL.Checked := True Else F.rbTminL.Checked := False;
      // taille holo
      Y := Buffer[3] + Buffer[4] * 256;
      F.edCoteHolo.Text := IntToStr(Y);
      // echelle XY
      Y := Buffer[5] + Buffer[6] * 256;
      F.edEchXY.Text := IntToStr(Y);
      // EchPZ
      FileRead(HandleFichier, Buffer, 1);
      X := Buffer[0];
      FileRead(HandleFichier, Buffer, X);
      F.edEchPZ.Text := '';
      For i := 0 To X - 1 Do
      Begin
      	If Buffer[i] = Byte('.') Then Buffer[i] := Byte(FloatToStr(0.5)[2]);
      	F.edEchPZ.Text := F.edEchPZ.Text + Char(Buffer[i]);
      End;
      // EchTZ
      FileRead(HandleFichier, Buffer, 1);
      X := Buffer[0];
      FileRead(HandleFichier, Buffer, X);
      F.edEchTZ.Text := '';
      For i := 0 To X - 1 Do
      Begin
      	If Buffer[i] = Byte('.') Then Buffer[i] := Byte(FloatToStr(0.5)[2]);
      	F.edEchTZ.Text := F.edEchTZ.Text + Char(Buffer[i]);
      End;
      // Epsilon
      FileRead(HandleFichier, Buffer, 1);
      X := Buffer[0];
      FileRead(HandleFichier, Buffer, X);
      F.edEpsilon.Text := '';
      For i := 0 To X - 1 Do
      Begin
      	If Buffer[i] = Byte('.') Then Buffer[i] := Byte(FloatToStr(0.5)[2]);
      	F.edEpsilon.Text := F.edEpsilon.Text + Char(Buffer[i]);
      End;
      // nb de points
      FileRead(HandleFichier, Buffer, 2);
      nbObjets := Buffer[0] + Buffer[1] * 256;
      SetLength(Objets, nbObjets);
      // donnes
      For i := 0 To nbObjets - 1 Do
      Begin
        If FileRead(HandleFichier, Buffer, 3) = 0 Then Raise Efichier.Create('Il s''est produit une erreur fichier');
        Objets[i] := THoloObj.Create();
        Objets[i].X := Byte(Buffer[0]);
        Objets[i].Y := Byte(Buffer[1]);
        Objets[i].Z := Byte(Buffer[2]);
        ImageXY.Canvas.Pixels[Objets[i].X, Objets[i].Y] := clBlack;
        ImageZY.Canvas.Pixels[Objets[i].Z, Objets[i].Y] := clBlack;
      End;
      Enreg := True;
    Finally FileClose(HandleFichier) End;
    sbSupprimer.Caption := '   Supprimer (' + IntToStr(nbObjets) + ' pts)';
    btnCalculer.Enabled := True;
    miCalculer.Enabled := True;
    btnImprimer.Enabled := True;
    miImprimer.Enabled := True;
    miEnregistrerSous.Enabled := True;
    miEnregistrer.Enabled := True;
    NoirBlanc := False;
    ActiverPt(-1, -1, True)
  End;
  ActiveControl := nil;
	edCoteHoloExit(Sender);
end;

//---------------------------------------------------------------------------------------------
// miEnregHolo.Clic
procedure TF.miEnregHoloClick(Sender: TObject);
begin
  dlgSave.DefaultExt := 'bmp';
  dlgSave.Filter := 'Images bitmaps (*.bmp)|*bmp';
  If dlgSave.Execute Then FHolo.Image1.Picture.SaveToFile(dlgSave.FileName);
end;

//---------------------------------------------------------------------------------------------
// miNouveau.Clic
procedure TF.miNouveauClick(Sender: TObject);
begin
  nbObjets := 0;
  SetLength(Objets, 0);
  ObjActif := -1;
  ImageXY.Canvas.FillRect(Rect(0, 0, 201, 201));
  ImageZY.Canvas.FillRect(Rect(0, 0, 201, 201));
  btnCalculer.Enabled := False;
  btnMontrer.Enabled := False;
  btnImprimer.Enabled := False;
  miEnregistrer.Enabled := False;
  miEnregistrerSous.Enabled := False;
  miEnregHolo.Enabled := False;
  miCalculer.Enabled := False;
  miMontrer.Enabled := False;
  miImprimer.Enabled := False;
  Enreg := False;
  NoirBlanc := False;
  gbSelection.Enabled := False;
  ActiveControl := nil;
end;

//**********************************************************************************************
//
//**********************************************************************************************

//---------------------------------------------------------------------------------------------
// miQuitter.Clic
procedure TF.miQuitterClick(Sender: TObject);
begin
  Application.Terminate();
end;

//---------------------------------------------------------------------------------------------
// miApropos.Clic
procedure TF.miAproposClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

//---------------------------------------------------------------------------------------------
// miRubrAide.Clic
procedure TF.miRubrAideClick(Sender: TObject);
begin
  ShellExecute(0, nil, PChar('Aide.txt'), nil, nil, SW_NORMAL);
end;


End.

